dc3dd 7.0.0
DCCI 
Richard Cordovano
2009-09-11

New Features:
-------------
The command line options supported by dc3dd are significantly changed in
7.0.0. For a full listing of the command line options, please consult
Options_Reference.txt or execute dc3dd using the --help option:

$ ./dc3dd --help 

The command line is now more rigorously validated to reduce the
likelihood of performing a run contrary to user intent. This is done
to minimize reading of the input device. Examples of command lines for
common uses of dc3dd are provided in Sample_Commands.txt.  

Release 7.0.0 replaces the byte-by-byte comparison verification
capability of prior releases with a verification capability that hashes
imaging outputs and compares output hash(es) to input hash(es). This
new verification capability does not require a second read of the input
device. 

It is now possible to specify more than one output file and to mix split
and unsplit outputs, where splitting an output refers to writing to a
set of files rather than to a single file.

Devices are now always probed for size, and the size of the device in 
sectors and sector size is reported. It is however, also now possible to
explicitly specify the sector size dc3dd is to use, overriding the
probed sector size (for devices) or assumed sector size (for files).  

Progress display is now always on and various options for formatting
output are now provided.

Building dc3dd:
---------------
dc3dd is distributed as source code and must be compiled before use.
The default configuration can be built and installed to /usr/local/bin
with the following commands:

$ tar zxvf dc3dd-7.0.0.tar.gz
$ cd dc3dd-7.0.0
$ ./configure
$ make
$ sudo make install

Note that autoconf-1.10.1 and gperf may need to be installed prior to
execution of the above commands.

dc3dd can be customized at compile-time with various options.
The available options are as follows, and can be verified after
compilation using the --flags command line option: 

-DDEFAULT_HASH_MD5
(equivalent to hash=md5 command-line option)

-DDEFAULT_HASH_SHA1
(equivalent to hash=sha1 command-line option)

-DDEFAULT_HASH_SHA256
(equivalent to hash=sha256 command-line option)

-DDEFAULT_HASH_SHA512
(equivalent to hash=sha512 command-line option)

-DDEFAULT_OUTPUT_FILE_SIZE=BYTES
(equivalent to ofsz=BYTES command-line option)

-DDEFAULT_VERBOSE_REPORTING
(equivalent to verb=on command-line option)

-DDEFAULT_COMPACT_REPORTING
(equivalent to nwspc=on command-line option)

-DDEFAULT_DECIMAL_BYTES_REPORTING
(equivalent to dbr=on command-line option)

--enable-hpadco
Enable checking ATA/SATA drives for hidden areas
No command-line equivalent, cannot be overridden.

These options are enabled by including them in the CFLAGS argument to
configure. For example, to enable MD5 hashing and default output file
size:

$ ./configure CFLAGS="-O2 -DDEFAULT_HASH_MD5 
-DDEFAULT_OUTPUT_FILE_SIZE=1900M"

The program can be statically linked by adding "-static" to the CFLAGS
compile options:

$ ./configure CFLAGS="-O2 -static"

Portability Notes:
------------------
Mac OS X:
To enable error recovery, use /dev/rdisk* instead of /dev/disk*

Windows:
dc3dd can be compiled using Cygwin, but bad sectors can put the program
into an infinite loop due to bugs in Cygwin.

Please send all correspondence to: dc3dd@dc3.mil
